
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class SubjectsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const subjects = await db.subjects.create(
            {
                id: data.id || undefined,
        
        subject_name: data.subject_name
        ||
        null
            ,
            
        subject_code: data.subject_code
        ||
        null
            ,
            
        description: data.description
        ||
        null
            ,
            
        is_active: data.is_active
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await subjects.setSchool( data.school || null, {
            transaction,
        });
        
        await subjects.setGrade_level( data.grade_level || null, {
            transaction,
        });
        

        

        

        return subjects;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const subjectsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                subject_name: item.subject_name
            ||
            null
            ,
            
                subject_code: item.subject_code
            ||
            null
            ,
            
                description: item.description
            ||
            null
            ,
            
                is_active: item.is_active
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const subjects = await db.subjects.bulkCreate(subjectsData, { transaction });

        // For each item created, replace relation files
        

        return subjects;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const subjects = await db.subjects.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.subject_name !== undefined) updatePayload.subject_name = data.subject_name;
        
        
        if (data.subject_code !== undefined) updatePayload.subject_code = data.subject_code;
        
        
        if (data.description !== undefined) updatePayload.description = data.description;
        
        
        if (data.is_active !== undefined) updatePayload.is_active = data.is_active;
        
        
        updatePayload.updatedById = currentUser.id;

        await subjects.update(updatePayload, {transaction});

        
        
        if (data.school !== undefined) {
            await subjects.setSchool(
              
              data.school,
              
              { transaction }
            );
        }
        
        if (data.grade_level !== undefined) {
            await subjects.setGrade_level(
              
              data.grade_level,
              
              { transaction }
            );
        }
        

        
        

        

        return subjects;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const subjects = await db.subjects.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of subjects) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of subjects) {
                await record.destroy({transaction});
            }
        });


        return subjects;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const subjects = await db.subjects.findByPk(id, options);

        await subjects.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await subjects.destroy({
            transaction
        });

        return subjects;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const subjects = await db.subjects.findOne(
            { where },
            { transaction },
        );

        if (!subjects) {
            return subjects;
        }

        const output = subjects.get({plain: true});

        
        
        
        
        
        
        
        
        
        output.teaching_assignments_subject = await subjects.getTeaching_assignments_subject({
            transaction
        });
        
        
        output.homeworks_subject = await subjects.getHomeworks_subject({
            transaction
        });
        
        
        
        
        
        
        
        output.gradebooks_subject = await subjects.getGradebooks_subject({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.school = await subjects.getSchool({
            transaction
        });
        
        
        output.grade_level = await subjects.getGrade_level({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userSchools = (user && user.schools?.id) || null;
        

        
        if (userSchools) {
            if (options?.currentUser?.schoolsId) {
                where.schoolsId = options.currentUser.schoolsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.schools,
        as: 'school',
        
      },

      {
        model: db.grade_levels,
        as: 'grade_level',
        
        where: filter.grade_level ? {
          [Op.or]: [
            { id: { [Op.in]: filter.grade_level.split('|').map(term => Utils.uuid(term)) } },
            {
              grade_name: {
                [Op.or]: filter.grade_level.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.subject_name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'subjects',
                        'subject_name',
                        filter.subject_name,
                    ),
                };
            }
            
            if (filter.subject_code) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'subjects',
                        'subject_code',
                        filter.subject_code,
                    ),
                };
            }
            
            if (filter.description) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'subjects',
                        'description',
                        filter.description,
                    ),
                };
            }
            

            
            

            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.is_active) {
                where = {
                    ...where,
                is_active: filter.is_active,
            };
            }
            


      
      if (filter.school) {
        const listItems = filter.school.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          schoolId: {[Op.or]: listItems}
        };
      }
      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.schoolsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.subjects.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'subjects',
                        'subject_name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.subjects.findAll({
            attributes: [ 'id', 'subject_name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['subject_name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.subject_name,
        }));
    }

    
};

